Imports System.IO
Imports System.IO.File

Public Class Form1
    Private Const NUM_VALUES As Integer = 10

    Private m_TextBoxes() As TextBox

    ' Load saved values.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        m_TextBoxes = New TextBox() {TextBox1, TextBox2, TextBox3, TextBox4, TextBox5, TextBox6, TextBox7, TextBox8, TextBox9, TextBox10}

        ' Get the file name.
        Dim file_name As String = GetFileName()

        ' See if the file exists.
        If Exists(file_name) Then
            ' Open the file.
            Dim fs As New FileStream(file_name, FileMode.Open)

            ' Create a BinaryReader for the FileStream.
            Dim binary_reader As New BinaryReader(fs)
            fs.Position = 0

            ' Read the integer values.
            Dim integers(NUM_VALUES - 1) As Integer
            For i As Integer = 0 To NUM_VALUES - 1
                integers(i) = binary_reader.ReadInt32()
            Next i
            binary_reader.Close()
            fs.Dispose()

            ' Display values.
            For i As Integer = 0 To NUM_VALUES - 1
                m_TextBoxes(i).Text = integers(i).ToString()
            Next i
        End If
    End Sub

    ' Save the current values.
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' Get the file name.
        Dim file_name As String = GetFileName()

        ' Create the file.
        Using fs As New FileStream(file_name, FileMode.Create)
            ' Create a BinaryWriter for the FileStream.
            Dim binary_writer As New BinaryWriter(fs)

            ' Get the values.
            Dim integers(NUM_VALUES - 1) As Integer
            For i As Integer = 0 To NUM_VALUES - 1
                integers(i) = Val(m_TextBoxes(i).Text)
            Next i

            ' Write the values.
            For i As Integer = 0 To NUM_VALUES - 1
                binary_writer.Write(integers(i))
            Next i
            binary_writer.Close()
        End Using
    End Sub

    Private Function GetFileName() As String
        Dim file_name As String = Application.StartupPath
        If file_name.EndsWith("\bin\Debug") Then file_name = file_name.Substring(0, file_name.Length - 10)
        If Not file_name.EndsWith("\") Then file_name &= "\"
        Return file_name & "numbers.dat"
    End Function
End Class
